//+------------------------------------------------------------------+
//|                                                        HLv01.mq4 |
//|                        Copyright 2014, Metaquotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Metaquotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

input int MagicNumber=12345;
input double Lot=0.1;
input int SL=200;
input bool order2=true;
input int Distance2=20;
input int SL2=200;
input bool order3=true;
input int Distance3=20;
input int SL3=200;
input int PipsTPDecreament=5;
input int SignalGap=4;
input int ShowBars=500;
input int FastMAPeriod=5;
input ENUM_MA_METHOD FastMAMethod=MODE_SMA;
input int FastMAShift=0;
input ENUM_APPLIED_PRICE FastMAAppliedPrice=PRICE_CLOSE;
input int FastMASignalCandle=1;
input int SlowMAPeriod=20;
input ENUM_MA_METHOD SlowMAMethod=MODE_SMA;
input int SlowMAShift=0;
input ENUM_APPLIED_PRICE SlowMAAppliedPrice=PRICE_CLOSE;
input int SlowMASignalCandle=1;
input int StochasticK=5;
input int StochasticD=3;
input int StochasticSlowing=3;
input ENUM_MA_METHOD StochasticMAMethod=MODE_SMA;
input ENUM_STO_PRICE StochasticPriceFile=STO_LOWHIGH;
input ENUM_INDEXBUFFER_TYPE StochasticMode=MODE_MAIN;
input int StochasticSignalCandle=1;
input int StochasticOverBought=80;
input int StochasticOverSold=20;
input bool CLOSE_TRADE_NOW=false;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Comment("");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   processing();
  }
//+------------------------------------------------------------------+
double stochastic(){
  return(iStochastic(NULL,0,StochasticK,StochasticD,StochasticSlowing,StochasticMAMethod,StochasticPriceFile,StochasticMode,StochasticSignalCandle));
}
double highlow(int buffer,int pos){
  return(iCustom(NULL,0,"HighLow",SignalGap,ShowBars,buffer,pos));
}
double takeprofit(int ordtype){
  double tp;
  if(ordtype==0){
    tp=highlow(0,0);
  }
  else {
    tp=highlow(1,0);
  }
  return(tp);
}
string trend(){
  string tend;
  if(iMA(NULL,0,FastMAPeriod,FastMAShift,FastMAMethod,FastMAAppliedPrice,FastMASignalCandle)>iMA(NULL,0,SlowMAPeriod,SlowMAShift,SlowMAMethod,SlowMAAppliedPrice,SlowMASignalCandle)){
    tend="UP";
  }
  else {
    tend="DOWN";
  }
  return(tend);
}
bool buysignal(){
  return(newcandle() && trend()=="UP" && stochastic()<StochasticOverSold);
}
bool sellsignal(){
  return(newcandle() && trend()=="DOWN" && stochastic()>StochasticOverBought);
}  
bool newcandle(){
  static datetime time=0;
  bool isnew;
  if(time!=Time[0]){
    isnew=true;
  }
  else {
    isnew=false;
  }
  time=Time[0];
  return(isnew);
}
int sendbuy(){
  int ticket=-1;
  while(ticket==-1 && !IsStopped()){
    ticket=OrderSend(Symbol(),OP_BUY,Lot,Ask,1,0.0,0.0,NULL,MagicNumber,0,clrBlue);
    while(ticket>0 && SL>0 && !IsStopped()){
      if(OrderSelect(ticket,SELECT_BY_TICKET) && OrderModify(ticket,0.0,Ask-SL*point(),takeprofit(0),0)){
        break;
      }
      RefreshRates();
    }
    RefreshRates();
  }
  return(ticket);
}
int sendbuylimit(double prc,double sl,double tp){
  int ticket=-1;
  while(ticket==-1 && !IsStopped()){
    ticket=OrderSend(Symbol(),OP_BUYLIMIT,Lot,prc,0,sl,tp,NULL,MagicNumber,0,clrBlue);
    if(ticket!=-1) break;
  }
  return(ticket);
}
int sendselllimit(double prc,double sl,double tp){
  int ticket=-1;
  while(ticket==-1 && !IsStopped()){
    ticket=OrderSend(Symbol(),OP_SELLLIMIT,Lot,prc,0,sl,tp,NULL,MagicNumber,0,clrRed);
    if(ticket!=-1) break;
  }
  return(ticket);
}
int sendsell(){
  int ticket=-1;
  while(ticket==-1 && !IsStopped()){
    ticket=OrderSend(Symbol(),OP_SELL,Lot,Bid,1,0.0,0.0,NULL,MagicNumber,0,clrRed);
    while(ticket>0 && SL>0 && !IsStopped()){
      if(OrderSelect(ticket,SELECT_BY_TICKET) && OrderModify(ticket,0.0,Bid+SL*point(),takeprofit(1),0)){
        break;
      }
      RefreshRates();
    }
    RefreshRates();
  }
  return(ticket);
}  
double GetCurrentTPBuy(){
  double tp=0.0;
  for(int x=0;x<OrdersTotal();x++){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY){
      tp=NormalizeDouble(OrderTakeProfit(),Digits);
      break;
    }
  }
  return(tp);
}
double GetCurrentTPSell(){
  double tp=0.0;
  for(int x=0;x<OrdersTotal();x++){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL){
      tp=NormalizeDouble(OrderTakeProfit(),Digits);
      break;
    }
  }
  return(tp);
} 
bool modifytpbuy(double decreament){
  bool modified=false;
  int total=OrdersTotal();
  double mtp=0.0;
  for(int x=0;x<total;x++){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY){
      if(mtp==0.0){
        mtp=OrderTakeProfit()-decreament*point();
      }
      modified=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),mtp,0);
    }
  }
  return(modified);
}           
bool modifytpsell(double decreament){
  bool modified=false;
  int total=OrdersTotal();
  double mtp=0.0;
  for(int x=0;x<total;x++){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL){
    if(mtp==0.0){
        mtp=OrderTakeProfit()+decreament*point();
      }
      modified=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit()+decreament*point(),0);
    }
  }
  return(modified);
} 
void istpneedtochange(int type){
  if(type==0 && takeprofit(0)<GetCurrentTPBuy()){
    ResetLastError();
    modifytpbuy(PipsTPDecreament);
  }
  if(type==1 && takeprofit(1)>GetCurrentTPSell()){
    ResetLastError();
    modifytpsell(PipsTPDecreament);
  } 
}
int total(int type){
  int counter=0;
  for(int x=OrdersTotal()-1;x>=0;x--){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==type){
      counter++;
    }
  }
  return(counter);
}
 
void closeallorder(){
  while((total(0)!=0 || total(1)!=0) && !IsStopped()){
    for(int x=OrdersTotal()-1;x>=0;x--){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol()){
      bool closed=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),1);
    }
    }
  }
}   
void deleteorder(){
    for(int try=0;try<100;try++)
    for(int x=OrdersTotal()-1;x>=0;x--){
    if(OrderSelect(x,0) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()>OP_SELL){
      bool del=OrderDelete(OrderTicket());
    }
  }
} 
void processing(){ 
  if(total(OP_BUY)==0 && total(OP_SELL)==0 && (total(OP_BUYLIMIT)!=0 || total(OP_SELLLIMIT)!=0)){
    deleteorder();
    return;
  } 
  int tot=total(OP_BUY)+total(OP_SELL)+total(OP_BUYLIMIT)+total(OP_SELLLIMIT);
  if(tot==0 && buysignal()){
    int t=sendbuy();
    double prc=0.0,tp=0.0;
    while(t>0 && !IsStopped()) {
      if(OrderSelect(t,SELECT_BY_TICKET)){
        prc=OrderOpenPrice();
        tp=OrderTakeProfit();
        break;
      }
    }
    tp=GetCurrentTPBuy();
    if(order2){
      sendbuylimit(prc-Distance2*point(),(prc-Distance2*point())-SL2*point(),tp);
    }
    if(order3){
      sendbuylimit(prc-(Distance2+Distance3)*point(),(prc-(Distance2+Distance3)*point())-SL3*point(),tp);
    }
    return;
  }
  if(tot==0 && sellsignal()){
    int t=sendsell();
    double prc=0.0,tp=0.0;
    while(t>0 && !IsStopped()) {
      if(OrderSelect(t,SELECT_BY_TICKET)){
        prc=OrderOpenPrice();
        tp=OrderTakeProfit();
        break;
      }
    }
    tp=GetCurrentTPSell();
    if(order2){
      sendselllimit(prc+Distance2*point(),(prc+Distance2*point())+SL2*point(),tp);
    }
    if(order3){
      sendselllimit(prc+(Distance2+Distance3)*point(),(prc+(Distance2+Distance3)*point())+SL3*point(),tp);
    }
    return;
  }
  if(total(0)!=0 || total(1)!=0){
    istpneedtochange(0);
    istpneedtochange(1);
  }  
  string text="\nEA Name: "+WindowExpertName();
  text=text+"\n\nCurrent order: "+IntegerToString(total(0) + total(1));
  text=text+"\n\nCurrent trend: "+trend();
  text=text+"\n\nStochastic value: "+DoubleToStr(stochastic(),Digits);
  text=text+"\n\nOverBought: "+IntegerToString(StochasticOverBought);
  text=text+"\n\nOverSold: "+IntegerToString(StochasticOverSold);
  Comment(text);
  if(CLOSE_TRADE_NOW){
    closeallorder();
  }  
}
double point(){
  double p=Point();
  if(Digits%2==1){
    p*=10.0;
  }
  return(p);
}    